local function output(outStr)
    DEFAULT_CHAT_FRAME:AddMessage( "NeedForMog: ".. tostring(outStr) )
end
local frame = CreateFrame("FRAME", "NEEDFORTRANSMOGAddonFrame");
NEEDFORTRANSMOG_Interface = {}
function NEEDFORTRANSMOG_Interface:setIsEnabled(isEnabled,force)
    local SAVE = SV_NEED_FOR_TRANSMOG
    local changed = isEnabled ~= SAVE.isEnabled or force
    if isEnabled and changed then
        frame:RegisterEvent("START_LOOT_ROLL");
    elseif not isEnabled and changed then
        frame:UnregisterEvent("START_LOOT_ROLL");
    end

    if changed then
        SAVE.isEnabled = isEnabled
    end

end

function NEEDFORTRANSMOG_Interface:loadDefaults(array)
    array.isEnabled = true

    array.needsEpics = false
    array.needsRares = true
    array.needsUncommons = true

    array.needInLFG = true
    array.needInNonLFG = true
    array.needInLFR = true
    array.needInNonLFR = true

    array.sendMessage = true
    array.message = NeedForTransmogPublic.L["NeedMessage"]

    array.greedBoEs = false
end
local model = CreateFrame("DressUpModel")
local SAVE = {}
model:SetAutoDress(false)


local cTip = CreateFrame("GameTooltip","NEEDFORTRANSMOGTooltip",nil,"GameTooltipTemplate")


function isBoE(itemLink)
    cTip:SetOwner(UIParent, "ANCHOR_NONE")
    cTip:SetHyperlink(itemLink)
    cTip:Show()
    for i = 1,cTip:NumLines() do
        if(_G["NEEDFORTRANSMOGTooltipTextLeft"..i]:GetText()== ITEM_BIND_ON_EQUIP) then
            return true
        end
    end
    cTip:Hide()
    return false
end


local function initNeedForMog()
    if not SV_NEED_FOR_TRANSMOG then
        SV_NEED_FOR_TRANSMOG = {}
        NEEDFORTRANSMOG_Interface:loadDefaults(SV_NEED_FOR_TRANSMOG)
    end

    SAVE = SV_NEED_FOR_TRANSMOG

    NEEDFORTRANSMOG_Interface:setIsEnabled(SAVE.isEnabled,true)

    -- TODO: Add saved variable loading into GUI
    -- isEnabled
    --
    --Types:
        --needEpics
        --needRares
        --needUncommons
    --Locations:
        --needInLFG
        --needInNonLFG
        --needInLFR
        --needInNonLFR
    -- Alert:
        --sendMessage
        --message
    -- Other:
        --greedBoEs
end



local function event_AddonLoaded(self,name)
    if name == "NeedForMog" then
        frame:UnregisterEvent("ADDON_LOADED")
        initNeedForMog()
    end

end


-- Thanks to MogIt!
local itemSourceID = {}
local function GetSourceFromItem(item)
    if not itemSourceID[item] then
        model:SetUnit("player")
        model:Undress()
        model:TryOn(item)
        for i = 1, 19 do
            local source, illusion = model:GetSlotTransmogSources(i)
            if source ~= 0 then
                itemSourceID[item] = source
                break
            end
        end
    end
    return itemSourceID[item]
end

-- Thanks to MogIt!
local function canCollect(item)
    local sourceID = GetSourceFromItem(item)
    if sourceID then
        local isInfoReady, canCollect = C_TransmogCollection.PlayerCanCollectSource(sourceID)
        if (isInfoReady and canCollect) then
            return true
        end
        -- TODO: Should I retry? I mean this is a single shot?  Tripple return?
        return false
    end
end


-- Thanks to MogIt!
local function isItemCollected(item)
    local itemID, _, _, slot = GetItemInfoInstant(item)
    if slot == "INVTYPE_BODY" or slot == "INVTYPE_TABARD" then
        return C_TransmogCollection.PlayerHasTransmog(itemID)
    end
    if type(item) == "number" then
        item = "item:"..item
    end
    local sourceID = GetSourceFromItem(item)
    if sourceID then
        local _, _, _, _, isCollected = C_TransmogCollection.GetAppearanceSourceInfo(sourceID)
        return isCollected
    end
end




local function shouldRoll(rollLink)
    --local isLeader, isTank, isHealer, isDamage = getLFGRoles()
    --local isLFG = isLeader or isTank or isHealer or isDamage
    local isLFG = IsInLFGDungeon()
    local isRaid = IsInRaid()
    local _, _, rarity = GetItemInfo(rollLink)
    --SV_NEED_FOR_TRANSMOG
    local isEpic = rarity == 4
    local isRare = rarity == 3
    local isUncommon = rarity == 2


    local typeRetval = (SAVE.needsEpics and isEpic ) or
                (SAVE.needsRares and isRare) or
                (SAVE.needsUncommons and isUncommon)

    local locationRetval = (SAVE.needInLFG and isLFG and not isRaid) or
                    (SAVE.needInNonLFG and not isLFG and not isRaid) or
                    (SAVE.needInLFR and isLFG and isRaid) or
                    (SAVE.needInNonLFR and not isLFG and isRaid)


    return typeRetval and locationRetval
end

local function event_StartLootRoll(self, rollID, rollTime)
    -- Sanity Check
    if not SAVE.isEnabled then
        return
    end

    -- RollLink is becoming nil?
    local rollLink = GetLootRollItemLink(rollID)

    local _,_,_,_,boP,canNeed, canGreed = GetLootRollItemInfo(rollID)

    if not shouldRoll(rollLink) then
        return
    end

    local isCollected = isItemCollected(rollLink)
    local canCollect = canCollect(rollLink)


    --output("canNeed: "..tostring(canNeed).. " canGreed: " ..tostring(canGreed).. " isCollected: "..tostring(isCollected) .. " canCollect: "..tostring(canCollect).." boP:" .. tostring(boP))

    if canNeed and not isCollected and canCollect then
        ConfirmLootRoll(rollID,1)
        if SAVE.sendMessage and SAVE.message then
            SendChatMessage("NeedForMog - " ..SAVE.message ..": " .. rollLink)
        else
            output(NeedForTransmogPublic.L.NeedMessage .. ": "..rollLink)
        end
    elseif canGreed and not isCollected and canCollect and boP then
        ConfirmLootRoll(rollID,2)
        output(NeedForTransmogPublic.L.GreedMessage .. ": "..rollLink)
    elseif canGreed and isCollected and not boP and SAVE.greedBoEs then
        ConfirmLootRoll(rollID,2)
        output(NeedForTransmogPublic.L.GreedMessage .. ": "..rollLink)
    end
end

local function eventHandler(self, event, ...)
    if (event == "START_LOOT_ROLL") then
        event_StartLootRoll(self,...)
    elseif (event == "ADDON_LOADED") then
        event_AddonLoaded(self,...)
    end
end
frame:SetScript("OnEvent", eventHandler);
frame:RegisterEvent("ADDON_LOADED");

